﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private BindingList<Element> elements;

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            elements = new BindingList<Element>();
            elements.Add(new Element("1"));
            //elements.Add(new Element("2"));
            //elements.Add(new Element("3"));
            //elements.Add(new Element("4"));
            //elements.Add(new Element("5"));
            //elements.Add(new Element("6"));
            //elements.Add(new Element("7"));
            //elements.Add(new Element("8"));

            ultraTree1.SetDataBinding(elements, null);

            ultraTree1.InitializeDataNode += new Infragistics.Win.UltraWinTree.InitializeDataNodeEventHandler(ultraTree1_InitializeDataNode);
            ultraTree1.BeforeNodeUpdate += new Infragistics.Win.UltraWinTree.BeforeNodeUpdateEventHandler(ultraTree1_BeforeNodeUpdate);
            ultraTree1.AfterActivate += new AfterNodeChangedEventHandler(ultraTree1_AfterActivate);

        }

        void ultraTree1_AfterActivate(object sender, NodeEventArgs e)
        {
            
        }
        
        void ultraTree1_BeforeNodeUpdate(object sender, Infragistics.Win.UltraWinTree.CancelableNodeEventArgs e)
        {
            throw new NotImplementedException();
        }

        void ultraTree1_InitializeDataNode(object sender, Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
        {
            if (string.IsNullOrEmpty(((Element)e.Node.ListObject).DisplayText))
            {
                e.Node.Cells["DisplayText"].AllowEdit = AllowCellEdit.Full;
                e.Node.BeginCellEdit(this.ultraTree1.ColumnSettings.RootColumnSet.Columns["DisplayText"]);
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            elements.Add(new Element(string.Empty));
        }
    }

    public class Element
    {
        public string DisplayText { get; set; }

        public Element(string displayText)
        {
            DisplayText = displayText;
        }
    }
}
